/*
 * @lc app=leetcode.cn id=322 lang=javascript
 *
 * [322] 零钱兑换
 *
 * https://leetcode-cn.com/problems/coin-change/description/
 *
 * algorithms
 * Medium (28.76%)
 * Total Accepted:    6.5K
 * Total Submissions: 22K
 * Testcase Example:  '[1,2,5]\n11'
 *
 * 给定不同面额的硬币 coins 和一个总金额
 * amount。编写一个函数来计算可以凑成总金额所需的最少的硬币个数。如果没有任何一种硬币组合能组成总金额，返回 -1。
 *
 * 示例 1:
 *
 * 输入: coins = [1, 2, 5], amount = 11
 * 输出: 3
 * 解释: 11 = 5 + 5 + 1
 *
 * 示例 2:
 *
 * 输入: coins = [2], amount = 3
 * 输出: -1
 *
 * 说明:
 * 你可以认为每种硬币的数量是无限的。
 *
 */
/**
 * @param {number[]} coins
 * @param {number} amount
 * @return {number}
 */
// 背包
var coinChange = function(coins, amount) {
  if (!coins) {
    return -1
  }
  let dp = new Array(amount + 1).fill(0)
  for (let i = 1; i <= amount; i++) {
    dp[i] = Infinity
    coins.forEach(val => {
      if (i >= val && dp[i - val] != -1 && val >= 0) {
        dp[i] = Math.min(dp[i], dp[i - val] + 1)
      }
    })
    if (dp[i] === Infinity) {
      dp[i] = -1
    }
  }
  return dp[amount]
}
console.log(coinChange([1, 2, 5], 11))
